Graphics3D 800,600,32,0

;---------------------------------------------------
; FIRST LIGHT (Standart)

piv=CreatePivot()
lpoint=CreateSphere(2,piv)
EntityFX lpoint,1
ScaleEntity lpoint,0.1,0.1,0.1
PositionEntity lpoint,0,0,-5

light=CreateLight(1,lpoint)
LightRange light,200

;---------------------------------------------------
; SECOND LIGHT (Standart)

piv2=CreatePivot()
lpoint2=CreateSphere(2,piv2)
EntityFX lpoint2,1
ScaleEntity lpoint2,0.1,0.1,0.1
PositionEntity lpoint2,0,0,-5

light2=CreateLight(1,lpoint2)
LightRange light2,200

TurnEntity piv2,0,-90,0

;---------------------------------------------------
; LOADING SPECIAL TEXTURES AND OBJECTS...
fxcam=CreateCamera()
CameraClsColor fxcam,127,127,0

Lbox=LoadLightBox("LightCube\normalize","png")

ref=LoadTexture("spheremap1.JPG",1)
TextureBlend ref,2

AmbientTex=CreateTexture(1,1,1)
TextureBlend AmbientTex,3
argb= (((50 Shl 8) Or 50) Shl 8) Or 50
WritePixel 0,0,argb ,TextureBuffer(AmbientTex)

;---------------------------------------------------
; LITEX and REFTEX of first light

Litex=CreateTexture( 32,32, 128+256)
SetCubeMode Litex,2
TextureBlend Litex,3

Reftex=CreateTexture( 32,32, 128+256)
SetCubeMode Reftex,1
TextureBlend Reftex,2

;---------------------------------------------------------
; LITEX and REFTEX of second light

Litex2=CreateTexture( 32,32, 128+256)
SetCubeMode Litex2,2
TextureBlend Litex2,3

Reftex2=CreateTexture( 32,32, 128+256)
SetCubeMode Reftex2,1
TextureBlend Reftex2,2

;---------------------------------------------------------
; CREATE CAMERA

camera=CreateCamera()
PositionEntity camera,0,0,-8

; --------------------------------------------------------
; CREATE SPHERE

sphere=CreateSphere(32)
ScaleEntity sphere,2,2,2
UpdateNormals sphere
EntityFX sphere,1
EntityColor sphere,0,0,0
EntityAlpha sphere,1

sphere2=CreateSphere(32,sphere)
UpdateNormals sphere2
EntityFX sphere2,1
EntityColor sphere2,0,0,0
EntityAlpha sphere2,0.9

; Blics of first and second lights on the Sphere
Blicmesh=CopyMesh(sphere,sphere)
EntityFX Blicmesh,1
EntityColor Blicmesh,255,255,255
EntityBlend Blicmesh,3

Blicmesh2=CopyMesh(sphere2,sphere2)
EntityFX Blicmesh2,1
EntityColor Blicmesh2,255,255,255
EntityBlend Blicmesh2,3

;---------------------------------------------------------
; LOAD AND SET TEXTURES
tex_d=LoadTexture("diffuse.jpg",8) ;DIFFUSE
tex_b=LoadTexture("bump.jpg",8) ;BUMP
col=LoadTexture("color.jpg") ;RED
col2=LoadTexture("color2.jpg") ;GREEN
TextureBlend tex_d,2
TextureBlend tex_b,4
TextureBlend col,2
TextureBlend col2,2

EntityTexture sphere,Litex,0,0
EntityTexture sphere,tex_b,0,1
EntityTexture sphere,col,0,2
EntityTexture sphere,AmbientTex,0,3
EntityTexture sphere,tex_d,0,4

EntityTexture sphere2,Litex2,0,0
EntityTexture sphere2,tex_b,0,1
EntityTexture sphere2,col2,0,2
EntityTexture sphere2,AmbientTex,0,3
EntityTexture sphere2,tex_d,0,4

EntityTexture Blicmesh, Reftex,0,0
EntityTexture Blicmesh, tex_b,0,1
EntityTexture Blicmesh,col,0,2

EntityTexture Blicmesh2, Reftex2,0,0
EntityTexture Blicmesh2, tex_b,0,1
EntityTexture BlicMesh2,col2,0,2


;------------------------------------------------------------
;START (MAIN LOOP)

Global UP_key=200
Global DOWN_key=208
Global LEFT_key=203
Global RIGHT_key=205

While Not KeyDown(1)
	lr=KeyDown(RIGHT_key)-KeyDown(LEFT_key)
	ud=KeyDown(UP_key)-KeyDown(DOWN_key)
	
	TurnEntity piv,ud,lr,0
	;TurnEntity piv2,-ud,-lr,0
	TurnEntity sphere,0,-0.1,0

	RenderLight(Litex,light,fxcam,camera,Lbox,1)
	RenderBlic(ref,Reftex,light,fxcam,camera,40,1)	

	RenderLight(Litex2,light2,fxcam,camera,Lbox,1)
	RenderBlic(ref,Reftex2,light2,fxcam,camera,40,1)	

	UpdateWorld
	RenderWorld
	
	Rect 10,20,160,45,0
	Text 15,25,"Triangles: "+TrisRendered()
	Text 15,45,"Use arrow keys"
	
	Flip
	Wend
End


Function RenderBlic ( Ref, Reftex, light, fxcam, cam, size#=10, Intencity#=1)
	Local BlicSpr
	
	TFormNormal 0,0,1,light,0
	
	CameraViewport fxcam, 0,0,TextureWidth(Reftex), TextureHeight(Reftex)
	CameraProjMode fxcam,1
	CameraProjMode cam,0
	PositionEntity fxcam,65535,65535,65535
	
	BlicSpr=CreateSprite()
	EntityTexture BlicSpr,ref
	ScaleSprite BlicSpr,size#,size#
	SpriteViewMode BlicSpr,2
	EntityBlend BlicSpr,1
	EntityColor BlicSpr,255,255,255*Intencity#
	EntityFX BlicSpr,17
	PositionEntity BlicSpr,65535,65535,65535
	MoveEntity BlicSpr, -10*TFormedX(), -10*TFormedY(), -10*TFormedZ()
	PointEntity BlicSpr, fxcam
	
	
	tex_sz=TextureWidth(Reftex) 
	
	SetCubeFace Reftex,0 
	RotateEntity fxcam,0,90,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,1 
	RotateEntity fxcam,0,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,2 
	RotateEntity fxcam,0,-90,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,3 
	RotateEntity fxcam,0,180,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,4 
	RotateEntity fxcam,-90,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,5 
	RotateEntity fxcam,90,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex)
	
	FreeEntity BlicSpr
	
	CameraProjMode cam,1
	CameraProjMode fxcam,0
End Function

Function RenderLight ( Reftex, light, fxcam, cam, mesh, Intencity#=1)
	Local BlicSpr
	
	TFormNormal 0,0,1,light,0
	
	CameraViewport fxcam, 0,0,TextureWidth(Reftex), TextureHeight(Reftex)
	CameraProjMode fxcam,1
	CameraProjMode cam,0
	PositionEntity fxcam,65535,65535,65535
	
	ScaleEntity mesh,10,10,10
	EntityFX mesh,1
	EntityColor mesh,255,255,255*Intencity#
	PositionEntity mesh,65535,65535,65535
	AlignToVector mesh, TFormedX(), TFormedY(), TFormedZ(),0
	
	ShowEntity mesh
	
	
	tex_sz=TextureWidth(Reftex) 
	
	SetCubeFace Reftex,0 
	RotateEntity fxcam,0,90,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,1 
	RotateEntity fxcam,0,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,2 
	RotateEntity fxcam,0,-90,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,3 
	RotateEntity fxcam,0,180,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,4 
	RotateEntity fxcam,-90,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex) 
	
	SetCubeFace Reftex,5 
	RotateEntity fxcam,90,0,0 
	RenderWorld 
	CopyRect 0,0,tex_sz,tex_sz,0,0,BackBuffer(),TextureBuffer(Reftex)
	
	
	HideEntity mesh
	CameraProjMode cam,1
	CameraProjMode fxcam,0
End Function

Function LoadLightBox( file$, rashirenie$ )
	m=CreateMesh()
	
	b=LoadBrush( file$+"_pz."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,1,1:AddVertex s,+1,+1,-1,0,1
	AddVertex s,+1,-1,-1,0,0:AddVertex s,-1,-1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3:
	FreeBrush b
	
	b=LoadBrush( file$+"_nx."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,1,1:AddVertex s,+1,+1,+1,0,1
	AddVertex s,+1,-1,+1,0,0:AddVertex s,+1,-1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	
	b=LoadBrush( file$+"_nz."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,1,1:AddVertex s,-1,+1,+1,0,1
	AddVertex s,-1,-1,+1,0,0:AddVertex s,+1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	
	b=LoadBrush( file$+"_px."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,1,1:AddVertex s,-1,+1,-1,0,1
	AddVertex s,-1,-1,-1,0,0:AddVertex s,-1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	
	b=LoadBrush( file$+"_ny."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,1,1:AddVertex s,+1,+1,+1,0,1
	AddVertex s,+1,+1,-1,0,0:AddVertex s,-1,+1,-1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	
	b=LoadBrush( file$+"_py."+rashirenie$,49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,-1,-1,1,1:AddVertex s,+1,-1,-1,0,1
	AddVertex s,+1,-1,+1,0,0:AddVertex s,-1,-1,+1,1,0
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	FlipMesh m
	EntityFX m,1
	Return m
End Function